(*****************************************
 * Program testujacy szybkosc algorytmow *
 * sortowania prostych list (tablic)     *
 * bY AD95/FuzZTec                       *
 * BucketSort bY Biki of UNION/PIL       *
 *****************************************)

(*
   Lojalnie uprzedzam, ze bubble i simple sa diabelnie
   wolne, tak ze nie trzeba sie denerwowac, ze sie cos
   zwiesilo :)
   Aha. Jak komus brakuje komentarza, to niech pisze na
   kulasty@friko2.onet.pl (bubble,simple,quick)
   biki@student.man.radom.pl (bucket)
                                                       *)

{$G+,N-,Q-,R-,S-,V-}
uses dos;

const n=10000;

type ttab=array[1..n] of integer;
     ptab=^ttab;

var tab:ttab;
    t:word;
    h1,h2,m1,m2,s1,s2,ss1,ss2,h0,m0,s0,ss0:word;

var a:word;
    k:word;
    i,j:longint;

const s:longint=0;

function lzero(co:longint;i:byte):string;
var s:string;
begin
  str(co,s);
  while byte(s[0])<i do s:='0'+s;
  lzero:=s;
end;

procedure qsort(l,p:word);
begin
  inc(s);
  i:=l;j:=p;
  a:=tab[(i+j) shr 1];
  repeat
    while tab[i]<a do inc(i);
    while tab[j]>a do dec(j);
    if i<=j then
    begin
      k:=tab[i];
      tab[i]:=tab[j];
      tab[j]:=k;
      inc(i);
      dec(j);
    end;
  until i>j;
  if i<p then qsort(i,p);
  if l<j then qsort(l,j);{}
end;

procedure bsort;
var i,j,a:word;
begin
  for i:=2 to n do
  for j:=n downto i do
  if tab[j-1]>tab[j] then
  begin
    a:=tab[j-1];
    tab[j-1]:=tab[j];
    tab[j]:=a;
  end;
end;

procedure ssort;
var j,i,a,k:word;
begin
  for i:=1 to n-1 do
  begin
    k:=i;a:=tab[i];
    for j:=i+1 to n do
    if tab[j]<a then
    begin
      k:=j;
      a:=tab[j];
    end;
    tab[k]:=tab[i];
    tab[i]:=a;
  end;
end;

procedure bucksort;
var tabo:ptab;
    cum:array[0..255] of word;
    t:word;
    s,z:word;
begin
  new(tabo);
  for t:=0 to 255 do cum[t]:=0;
  for t:=1 to n do inc(cum[tab[t] and 255]);
  s:=0;
  for t:=0 to 255 do
  begin
    s:=s+cum[t];
    cum[t]:=s;
  end;
  for t:=n downto 1 do
  begin
    z:=tab[t] and 255;
    dec(cum[z]);
    tabo^[cum[z]+1]:=tab[t];
  end;
  for t:=0 to 255 do cum[t]:=0;
  for t:=1 to n do inc(cum[tabo^[t] shr 8]);
  s:=0;
  for t:=0 to 255 do
  begin
    s:=s+cum[t];
    cum[t]:=s;
  end;
  for t:=n downto 1 do
  begin
    z:=tabo^[t] shr 8;
    dec(cum[z]);
    tab[cum[z]+1]:=tabo^[t];
  end;
  dispose(tabo);
end;

procedure sub;
begin
  write(lzero(h1,2),':',lzero(m1,2),':',lzero(s1,2),'.',lzero(ss1,2),' -- ');
  writeln(lzero(h2,2),':',lzero(m2,2),':',lzero(s2,2),'.',lzero(ss2,2));
  if ss1>ss2 then begin ss2:=ss2+100;s1:=s1+1;end;
  if s1>s2 then begin s2:=s2+60;end;
  writeln('Total time : ',lzero(s2-s1,2),'.',lzero(ss2-ss1,2));
end;

procedure prepare(no:byte);
const name:array[0..3] of string=('Bubble Sort','Simple Sort','Quick Sort','Bucket Sort');
begin
  randomize;
  write(name[no],' : ');
  write('Losowanie.');
  for t:=1 to n do tab[t]:=random(32000);
  write('Sortowanie.');
  gettime(h1,m1,s1,ss1);
  case no of
    0:bsort;
    1:ssort;
    2:qsort(1,n);
    3:bucksort;
  end;
  gettime(h2,m2,s2,ss2);
  writeln;
  if no=2 then writeln(s,' odwolan');
  sub;
  writeln('-----');
end;

begin
  asm mov ax, 3;int 10h;end;
  prepare(0);
  prepare(1);
  prepare(2);
  prepare(3);
end.